// _VF[_[̓
struct VS_INPUT
{
	float4 Position        : POSITION ;         // W( [J )
	int4   BlendIndices0   : BLENDINDICES0 ;    // XLjOp Float^萔zCfbNX
	float4 BlendWeight0    : BLENDWEIGHT0 ;     // XLjOpEGCgl
	float3 Normal          : NORMAL0 ;          // @( [J )
	float4 Diffuse         : COLOR0 ;           // fBt[YJ[
	float4 Specular        : COLOR1 ;           // XyLJ[
	float4 TexCoords0      : TEXCOORD0 ;        // eNX`W
} ;

// _VF[_[̏o
struct VS_OUTPUT
{
	float4 Position        : POSITION ;         // W( vWFNV )
	float4 Diffuse         : COLOR0 ;           // fBt[YJ[
	float4 Specular        : COLOR1 ;           // XyLJ[
	float2 TexCoords0      : TEXCOORD0 ;        // eNX`W
	float2 ToonCoords0     : TEXCOORD1 ;        // gD[eNX`W
} ;

// }eAp[^
struct VS_CONST_MATERIAL
{
	float4 Diffuse ;                // }eAfBt[YJ[
	float4 Specular ;               // }eAXyLJ[
	float4 Power ;                  // }eAXyLnCCg̋
} ;

// Cgp[^
struct VS_CONST_LIGHT
{
	float4 Position ;               // W( r[ )
	float3 Direction ;              // ( r[ )
	float4 Diffuse ;                // fBt[YJ[
	float4 Specular ;               // XyLJ[
	float4 Ambient ;                // ArGgJ[ƃ}eÃArGgJ[Z
	float4 Range_FallOff_AT0_AT1 ;  // x:L  y:X|bgCgpFallOff  z:ɂ錸pp[^O  w:ɂ錸pp[^P
	float4 AT2_SpotP0_SpotP1 ;      // x:ɂ錸pp[^Q  y:X|bgCgpp[^O( cos( Phi / 2.0f ) )  z:X|bgCgpp[^P( 1.0f / ( cos( Theta / 2.0f ) - cos( Phi / 2.0f ) ) )
} ;



// C++ Őݒ肷萔̒`
float4              cfAmbient_Emissive        : register( c1  ) ;		// }eAG~bVuJ[ + }eAArGgJ[ * O[oArGgJ[
float4              cfProjectionMatrix[ 4 ]   : register( c2  ) ;		// r[@@@ˉes
float4              cfViewMatrix[ 3 ]         : register( c6  ) ;		// [h@@r[s
float4              cfTextureMatrix[ 3 ][ 2 ] : register( c88 ) ;		// eNX`Wps
float4              cfLocalWorldMatrix[ 162 ] : register( c94 ) ;		// [J@@[hs
VS_CONST_MATERIAL   cfMaterial                : register( c11 ) ;		// }eAp[^
VS_CONST_LIGHT      cfLight[ 1 ]              : register( c14 ) ;		// LCg̃p[^




// main֐
VS_OUTPUT main( VS_INPUT VSInput )
{
	VS_OUTPUT VSOutput ;
	float4 lLocalWorldMatrix[ 3 ] ;
	float4 lWorldPosition ;
	float4 lViewPosition ;
	float3 lWorldNrm ;
	float3 lViewNrm ;
	float4 lTotalDiffuse ;
	float4 lTotalSpecular ;
	float3 lLightDir ;
	float3 lLightTemp ;
	float3 lLightHalfVec ;
	float4 lLightLitParam ;
	float4 lLightLitDest ;
	float4 lTotalAmbient ;
	float lTotalLightGen ;


	// ̃t[̃uhs̍쐬
	lLocalWorldMatrix[ 0 ]  = cfLocalWorldMatrix[ VSInput.BlendIndices0.x + 0 ] * VSInput.BlendWeight0.x;
	lLocalWorldMatrix[ 1 ]  = cfLocalWorldMatrix[ VSInput.BlendIndices0.x + 1 ] * VSInput.BlendWeight0.x;
	lLocalWorldMatrix[ 2 ]  = cfLocalWorldMatrix[ VSInput.BlendIndices0.x + 2 ] * VSInput.BlendWeight0.x;

	lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.y + 0 ] * VSInput.BlendWeight0.y;
	lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.y + 1 ] * VSInput.BlendWeight0.y;
	lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.y + 2 ] * VSInput.BlendWeight0.y;

	lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.z + 0 ] * VSInput.BlendWeight0.z;
	lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.z + 1 ] * VSInput.BlendWeight0.z;
	lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.z + 2 ] * VSInput.BlendWeight0.z;

	lLocalWorldMatrix[ 0 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.w + 0 ] * VSInput.BlendWeight0.w;
	lLocalWorldMatrix[ 1 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.w + 1 ] * VSInput.BlendWeight0.w;
	lLocalWorldMatrix[ 2 ] += cfLocalWorldMatrix[ VSInput.BlendIndices0.w + 2 ] * VSInput.BlendWeight0.w;


	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// [JW[hWɕϊ
	lWorldPosition.x = dot( VSInput.Position, lLocalWorldMatrix[ 0 ] ) ;
	lWorldPosition.y = dot( VSInput.Position, lLocalWorldMatrix[ 1 ] ) ;
	lWorldPosition.z = dot( VSInput.Position, lLocalWorldMatrix[ 2 ] ) ;
	lWorldPosition.w = 1.0f ;

	// [hWr[Wɕϊ
	lViewPosition.x = dot( lWorldPosition, cfViewMatrix[ 0 ] ) ;
	lViewPosition.y = dot( lWorldPosition, cfViewMatrix[ 1 ] ) ;
	lViewPosition.z = dot( lWorldPosition, cfViewMatrix[ 2 ] ) ;
	lViewPosition.w = 1.0f ;

	// r[WˉeWɕϊ
	VSOutput.Position.x = dot( lViewPosition, cfProjectionMatrix[ 0 ] ) ;
	VSOutput.Position.y = dot( lViewPosition, cfProjectionMatrix[ 1 ] ) ;
	VSOutput.Position.z = dot( lViewPosition, cfProjectionMatrix[ 2 ] ) ;
	VSOutput.Position.w = dot( lViewPosition, cfProjectionMatrix[ 3 ] ) ;

	// _Wϊ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )




	// Cg̏ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// @r[Ԃ̊pxɕϊ =====================================================( Jn )

	// [JxNg[hxNgɕϊ
	lWorldNrm.x = dot( VSInput.Normal, lLocalWorldMatrix[ 0 ].xyz ) ;
	lWorldNrm.y = dot( VSInput.Normal, lLocalWorldMatrix[ 1 ].xyz ) ;
	lWorldNrm.z = dot( VSInput.Normal, lLocalWorldMatrix[ 2 ].xyz ) ;

	// [hxNgr[xNgɕϊ
	lViewNrm.x = dot( lWorldNrm, cfViewMatrix[ 0 ].xyz ) ;
	lViewNrm.y = dot( lWorldNrm, cfViewMatrix[ 1 ].xyz ) ;
	lViewNrm.z = dot( lWorldNrm, cfViewMatrix[ 2 ].xyz ) ;

	// @r[Ԃ̊pxɕϊ =====================================================( I )


	// fBt[YJ[ƃXyLJ[ƃArGgJ[̍vl
	lTotalDiffuse  = float4( 0, 0, 0, 0 ) ;
	lTotalSpecular = float4( 0, 0, 0, 0 ) ;
	lTotalAmbient  = float4( 0, 0, 0, 0 ) ;

	// Cǧvl̏
	lTotalLightGen = 0.0f ;




	// fBNViCg̏ *****************************************************( Jn )


	// Cg̕Zbg
	lLightDir = cfLight[ 0 ].Direction ;


	// fBt[YCgƃXyLCg̊pxvZ ===================( Jn )

	// @ƃCg̋txNgƂ̓ς lLightLitParam.x ɃZbg
	lLightLitParam.x = dot( lViewNrm, -lLightDir ) ;

	// n[txNǧvZ norm( ( norm( _ʒu王_ւ̃xNg ) + Cg̕ ) )
	lLightHalfVec = normalize( normalize( -lViewPosition.xyz ) - lLightDir ) ;

	// @ƃn[txNg̓ς lLightLitParam.y ɃZbg
	lLightLitParam.y = dot( lLightHalfVec, lViewNrm ) ;

	// XyL˗ lLightLitParam.w ɃZbg
	lLightLitParam.w = cfMaterial.Power.x ;

	// CgvZ
	lLightLitDest = lit( lLightLitParam.x, lLightLitParam.y, lLightLitParam.w ) ;

	// fBt[YCgƃXyLCg̊pxvZ ===================( I )


	// J[vZ ===========================================================( Jn )

	// Cg̃fBt[YJ[vlɉZ
	lTotalDiffuse  += cfLight[ 0 ].Diffuse ;

	// Cg̃ArGgJ[vlɉZ
	lTotalAmbient  += cfLight[ 0 ].Ambient ;

	// fBt[YJ[pxvlɉZ
	lTotalLightGen += lLightLitDest.y ;

	// XyLCgvl += XyLpxvZ * Cg̃XyLJ[
	lTotalSpecular += lLightLitDest.z * cfLight[ 0 ].Specular ;

	// XyLJ[vZ =================================================( I )


	// fBNViCg̏ *****************************************************( I )





	// Cg̏ ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )







	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( Jn )

	// o̓fBt[YJ[ = CgfBt[YJ[~ϒl * }eAfBt[YJ[ + ( }eÃArGgJ[ƃO[oArGgJ[Ẑƃ}eAG~bVuJ[Z )
	VSOutput.Diffuse = lTotalDiffuse * cfMaterial.Diffuse + cfAmbient_Emissive ;

	// At@̓fBt[YJ[̃At@̂܂܎g
	VSOutput.Diffuse.w = cfMaterial.Diffuse.w ;

	// o̓XyLJ[ = CgXyLJ[~ϒl * XyLJ[
	VSOutput.Specular = lTotalSpecular * cfMaterial.Specular ;

	// eNX`Wϊsɂϊsʂ̃eNX`WZbg
	VSOutput.TexCoords0.x = dot( VSInput.TexCoords0, cfTextureMatrix[ 0 ][ 0 ] ) ;
	VSOutput.TexCoords0.y = dot( VSInput.TexCoords0, cfTextureMatrix[ 0 ][ 1 ] ) ;

	// gD[eNX`W̓Cǧ
	VSOutput.ToonCoords0 = lTotalLightGen ;

	// o̓p[^Zbg ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++( I )



	// o̓p[^Ԃ
	return VSOutput ;
}
